#include "BorderSelector.h"

using namespace Taglut;

BorderSelector::BorderSelector(Mesh & mesh_t) : mesh(mesh_t) {
  mesh.clear();
}

BorderSelector::~BorderSelector() {

}


void BorderSelector::operator() (VertexID id1, VertexID id2, const Mesh & omesh) {
  if (omesh.isBoundaryEdge(id1, id2)) {
    std::map<VertexID, VertexID>::iterator it1 = translation.find(id1);
    std::map<VertexID, VertexID>::iterator it2 = translation.find(id2);

    if (it1 == translation.end()) {
      translation[id1] = mesh.getNbPoints();
      mesh.addPoint(omesh.point(id1));
      it1 = translation.find(id1);
    }

    if (it2 == translation.end()) {
      translation[id2] = mesh.getNbPoints();
      mesh.addPoint(omesh.point(id2));
      it2 = translation.find(id2);
    }

    Triangle t((*it1).second, (*it1).second, (*it2).second);
    mesh.addTriangle(t);
  }

}


